/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.tables.records.VDataquierMissinglistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierMissinglist extends TableImpl<VDataquierMissinglistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier_missinglist</code>
     */
    public static final VDataquierMissinglist V_DATAQUIER_MISSINGLIST = new VDataquierMissinglist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierMissinglistRecord> getRecordType() {
        return VDataquierMissinglistRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_missinglist.list</code>.
     */
    public final TableField<VDataquierMissinglistRecord, Integer> LIST = createField(DSL.name("list"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist.codes</code>.
     */
    public final TableField<VDataquierMissinglistRecord, String> CODES = createField(DSL.name("codes"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist.isocode</code>.
     */
    public final TableField<VDataquierMissinglistRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist.stata_codes</code>.
     */
    public final TableField<VDataquierMissinglistRecord, String> STATA_CODES = createField(DSL.name("stata_codes"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist.missingtype</code>.
     */
    public final TableField<VDataquierMissinglistRecord, String> MISSINGTYPE = createField(DSL.name("missingtype"), SQLDataType.CLOB, this, "");

    private VDataquierMissinglist(Name alias, Table<VDataquierMissinglistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierMissinglist(Name alias, Table<VDataquierMissinglistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_missinglist" as  SELECT mv.fk_missinglist AS list,
          string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS codes,
          t.isocode,
          string_agg((c.num_missingcode)::text, ' '::text) AS stata_codes,
          mc.name AS missingtype
         FROM (((((common_dd.t_core_missingvalue mv
           LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
           LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
           LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
           LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
           LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass)))
        WHERE (mc.name = ANY (ARRAY['jump'::text, 'missing'::text]))
        GROUP BY mv.fk_missinglist, t.isocode, mc.name;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_missinglist</code> table
     * reference
     */
    public VDataquierMissinglist(String alias) {
        this(DSL.name(alias), V_DATAQUIER_MISSINGLIST);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_missinglist</code> table
     * reference
     */
    public VDataquierMissinglist(Name alias) {
        this(alias, V_DATAQUIER_MISSINGLIST);
    }

    /**
     * Create a <code>common_dd.v_dataquier_missinglist</code> table reference
     */
    public VDataquierMissinglist() {
        this(DSL.name("v_dataquier_missinglist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierMissinglist as(String alias) {
        return new VDataquierMissinglist(DSL.name(alias), this);
    }

    @Override
    public VDataquierMissinglist as(Name alias) {
        return new VDataquierMissinglist(alias, this);
    }

    @Override
    public VDataquierMissinglist as(Table<?> alias) {
        return new VDataquierMissinglist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglist rename(String name) {
        return new VDataquierMissinglist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglist rename(Name name) {
        return new VDataquierMissinglist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglist rename(Table<?> name) {
        return new VDataquierMissinglist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist where(Condition condition) {
        return new VDataquierMissinglist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
